<template>
    <div v-on:click="setValue()">
        {{ value1 }}
        {{ value2() }}
        {{ value3 }}
        {{ value1Times10 }}
    </div>
</template>

<script>
export default {
    data() {
        return {
            value1: 1
        };
    },
    computed: {
        value3() {
            console.log('value3');
            return 3;
        },
        value1Times10() {
            console.log('value1Times10');
            return this.value1 * 10;
        }
    },
    watch: {
        value1: function(newValue, oldValue) {
            alert(`value1 has changed from ${oldValue} to ${newValue}`);
        }
    },
    methods: {
        value2() {
            console.log('value2');
            return 2;
        },
        setValue() {
            console.log('setValue');
            this.value1 = 2;
        }
    }
};
</script>

<style></style>
